// Generated by gtkmmproc -- DO NOT MODIFY!


#include <gstreamermm/parse.h>
#include <gstreamermm/private/parse_p.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gstenumtypes.h>
#include <gst/gstutils.h>
#include <gstreamermm/element.h>

namespace Gst
{

#ifdef GLIBMM_EXCEPTIONS_ENABLED
Glib::RefPtr<Element> Parse::launch(const Glib::ustring& pipeline_description)
#else
Glib::RefPtr<Element> Parse::launch(const Glib::ustring& pipeline_description, std::auto_ptr<Glib::Error>& error)
#endif //GLIBMM_EXCEPTIONS_ENABLED
{
  GError* gerror = 0;
  Glib::RefPtr<Element> retvalue = Glib::wrap(gst_parse_launch(pipeline_description.c_str(), &(gerror)));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
#else
  if(gerror)
    error = ::Glib::Error::throw_exception(gerror);
#endif //GLIBMM_EXCEPTIONS_ENABLED

  return retvalue;
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
Glib::RefPtr<Element> Parse::launchv(const gchar *argv[])
#else
Glib::RefPtr<Element> Parse::launchv(const gchar *argv[], std::auto_ptr<Glib::Error>& error)
#endif //GLIBMM_EXCEPTIONS_ENABLED
{
  GError* gerror = 0;
  Glib::RefPtr<Element> retvalue = Glib::wrap(gst_parse_launchv(argv, &(gerror)));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
#else
  if(gerror)
    error = ::Glib::Error::throw_exception(gerror);
#endif //GLIBMM_EXCEPTIONS_ENABLED

  return retvalue;
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
Glib::RefPtr<Element> Parse::get_bin(const Glib::ustring& bin_description, bool ghost_unconnected_pads)
#else
Glib::RefPtr<Element> Parse::get_bin(const Glib::ustring& bin_description, bool ghost_unconnected_pads, std::auto_ptr<Glib::Error>& error)
#endif //GLIBMM_EXCEPTIONS_ENABLED
{
  GError* gerror = 0;
  Glib::RefPtr<Element> retvalue = Glib::wrap(gst_parse_bin_from_description(bin_description.c_str(), ghost_unconnected_pads, &(gerror)));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror)
    ::Glib::Error::throw_exception(gerror);
#else
  if(gerror)
    error = ::Glib::Error::throw_exception(gerror);
#endif //GLIBMM_EXCEPTIONS_ENABLED

  return retvalue;
}

} //namespace Gst

namespace
{
} // anonymous namespace


Gst::ParseError::ParseError(Gst::ParseError::Code error_code, const Glib::ustring& error_message)
:
  Glib::Error (GST_PARSE_ERROR, error_code, error_message)
{}

Gst::ParseError::ParseError(GError* gobject)
:
  Glib::Error (gobject)
{}

Gst::ParseError::Code Gst::ParseError::code() const
{
  return static_cast<Code>(Glib::Error::code());
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
void Gst::ParseError::throw_func(GError* gobject)
{
  throw Gst::ParseError(gobject);
}
#else
//When not using exceptions, we just pass the Exception object around without throwing it:
std::auto_ptr<Glib::Error> Gst::ParseError::throw_func(GError* gobject)
{
  return std::auto_ptr<Glib::Error>(new Gst::ParseError(gobject));
}
#endif //GLIBMM_EXCEPTIONS_ENABLED

// static
GType Glib::Value<Gst::ParseError::Code>::value_type()
{
  return gst_parse_error_get_type();
}


