
#include <glib.h>

// Disable the 'const' function attribute of the get_type() functions.
// GCC would optimize them out because we don't use the return value.
#undef  G_GNUC_CONST
#define G_GNUC_CONST /* empty */

#include <gstreamerbasemm/wrap_init.h>
#include <glibmm/error.h>
#include <glibmm/object.h>

// #include the widget headers so that we can call the get_type() static methods:

#include "audioclock.h"
#include "colorbalance.h"
#include "colorbalancechannel.h"
#include "xoverlay.h"

extern "C"
{

//Declarations of the *_get_type() functions:

GType gst_audio_clock_get_type(void);
GType gst_color_balance_channel_get_type(void);

//Declarations of the *_error_quark() functions:

} // extern "C"


//Declarations of the *_Class::wrap_new() methods, instead of including all the private headers:

namespace GstBase {  class AudioClock_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class ColorBalanceChannel_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }

namespace GstBase { 

void wrap_init()
{
  // Register Error domains:

// Map gtypes to gtkmm wrapper-creation functions:
  Glib::wrap_register(gst_audio_clock_get_type(), &GstBase::AudioClock_Class::wrap_new);
  Glib::wrap_register(gst_color_balance_channel_get_type(), &GstBase::ColorBalanceChannel_Class::wrap_new);

  // Register the gtkmm gtypes:
  GstBase::AudioClock::get_type();
  GstBase::ColorBalanceChannel::get_type();

} // wrap_init()

} //GstBase


